/**
 *                           _    _   _ __    _ __
 *                          | |  | | | '_ \  | '_ \
 *                          | |  | | | |_) | | |_) |
 *                          | |  | | | .__/  | '_ )
 *                          | \__/ | | |     | |_) |
 *                          \______/ |_|     |_.__/
 *                          -------- _______ -------
 *
 *
 *  File:           music.c
 *  Description:    Musical Notes
 *  By:             ioan_florin.nitu
 *
 *   _______________________________________
 *  / Look for my W-USO ;)                  \
 *  \ (No, seriously, don't look...)        /
 *   ---------------------------------------
 *          \   ^__^
 *           \  (oo)\_______
 *              (__)\       )\/\
 *                  ||----w |
 *                  ||     ||
 *
 */

/** PROIECT
 *
 * music.c
 *
 * @author Nitu Ioan Florin Catalin
 * @group 333CC
 * @version 1.0
 * @since Rock 'n' Roll
 *
 * Copyright (c) 2019 PM
 *
 */

#include "music.h"

char *note_names[] = {"C ", "C#", "D ", "D#",
			"E ", "F ", "F#", "G ",
			"G#", "A ", "A#", "B "};
float note_freqs[] = {8.1758f, 8.6620f, 9.1770, 9.7227f,
			10.301f, 10.914f, 11.563f, 12.250f,
			12.979f, 13.750f, 14.568f, 15.434f};
char *note_pitch[] = {"   0", "   1", "   2", "   3",
			"   4", "   5", "   6", "   7"};

char *standard_names[] = {"E2", "A2", "D3",
				"G3", "B3", "E4"};
float standard_freqs[] = {82.407f, 110.000f, 146.830f,
				196.000f, 246.940f, 329.630f};

char *drop_d_names[] = {"D2", "A2", "D3",
			"G3", "B3", "E4"};
float drop_d_freqs[] = {73.416f, 110.000f, 146.830f,
			196.000f, 246.940f, 329.630f};

char *d_names[] = {"D2", "G2", "C3",
			"F3", "A3", "D4"};
float d_freqs[] = {73.416f, 97.999f, 130.810f,
			174.610f, 220.000f, 293.660f};

float get_freq(float note, int pitch)
{
	/* from a note in an octave to next octave multiply by two */
	float freq = (1 << (pitch + 1)) * note;
	return freq;
}

