/**
 *                           _    _   _ __    _ __
 *                          | |  | | | '_ \  | '_ \
 *                          | |  | | | |_) | | |_) |
 *                          | |  | | | .__/  | '_ )
 *                          | \__/ | | |     | |_) |
 *                          \______/ |_|     |_.__/
 *                          -------- _______ -------
 *
 *
 *  File:           stepper.c
 *  Description:    Stepper Motor
 *  By:             ioan_florin.nitu
 *
 *   _______________________________________
 *  / Look for my W-USO ;)                  \
 *  \ (No, seriously, don't look...)        /
 *   ---------------------------------------
 *          \   ^__^
 *           \  (oo)\_______
 *              (__)\       )\/\
 *                  ||----w |
 *                  ||     ||
 *
 */

/** PROIECT
 *
 * stepper.c
 *
 * @author Nitu Ioan Florin Catalin
 * @group 333CC
 * @version 1.0
 * @since Rock 'n' Roll
 *
 * Copyright (c) 2019 PM
 *
 */

#include "stepper.h"

void STEPPER_init(void)
{
	STEPPER_DDR_IN123 |= (1 << STEPPER_IN1);
	STEPPER_DDR_IN123 |= (1 << STEPPER_IN2);
	STEPPER_DDR_IN123 |= (1 << STEPPER_IN3);
	STEPPER_DDR_IN47 |= (1 << STEPPER_IN4);
	STEPPER_DDR_IN47 |= (1 << STEPPER_IN7);
}

void STEPPER_set(int in4, int in3, int in2, int in1)
{
	if (in1)
		STEPPER_PORT_IN123 |= (1 << STEPPER_IN1);
	else
		STEPPER_PORT_IN123 &= ~(1 << STEPPER_IN1);

	if (in2)
		STEPPER_PORT_IN123 |= (1 << STEPPER_IN2);
	else
		STEPPER_PORT_IN123 &= ~(1 << STEPPER_IN2);

	if (in3)
		STEPPER_PORT_IN123 |= (1 << STEPPER_IN3);
	else
		STEPPER_PORT_IN123 &= ~(1 << STEPPER_IN3);

	if (in4)
		STEPPER_PORT_IN47 |= (1 << STEPPER_IN4);
	else
		STEPPER_PORT_IN47 &= ~(1 << STEPPER_IN4);
}

void STEPPER_rotation(int angle)
{
	if (angle > 0) {
		for (int i = 0; i < STEPPER_STEPS / (360 / angle); i++) {
			STEPPER_set(0, 0, 0, 1);
			_delay_ms(1);
			STEPPER_set(0, 0, 1, 1);
			_delay_ms(1);
			STEPPER_set(0, 0, 1, 0);
			_delay_ms(1);
			STEPPER_set(0, 1, 1, 0);
			_delay_ms(1);
			STEPPER_set(0, 1, 0, 0);
			_delay_ms(1);
			STEPPER_set(1, 1, 0, 0);
			_delay_ms(1);
			STEPPER_set(1, 0, 0, 0);
			_delay_ms(1);
			STEPPER_set(1, 0, 0, 1);
			_delay_ms(1);
		}
	} else {
		for (int i = 0; i < STEPPER_STEPS / (360 / -angle); i++) {
			STEPPER_set(1, 0, 0, 1);
			_delay_ms(1);
			STEPPER_set(1, 0, 0, 0);
			_delay_ms(1);
			STEPPER_set(1, 1, 0, 0);
			_delay_ms(1);
			STEPPER_set(0, 1, 0, 0);
			_delay_ms(1);
			STEPPER_set(0, 1, 1, 0);
			_delay_ms(1);
			STEPPER_set(0, 0, 1, 0);
			_delay_ms(1);
			STEPPER_set(0, 0, 1, 1);
			_delay_ms(1);
			STEPPER_set(0, 0, 0, 1);
			_delay_ms(1);
		}
	}
	STEPPER_set(0, 0, 0, 0);
	_delay_ms(1);
}

