/**
 *                           _    _   _ __    _ __
 *                          | |  | | | '_ \  | '_ \
 *                          | |  | | | |_) | | |_) |
 *                          | |  | | | .__/  | '_ )
 *                          | \__/ | | |     | |_) |
 *                          \______/ |_|     |_.__/
 *                          -------- _______ -------
 *
 *
 *  File:           stepper.h
 *  Description:    Stepper Motor
 *  By:             ioan_florin.nitu
 *
 *   _______________________________________
 *  / Look for my W-USO ;)                  \
 *  \ (No, seriously, don't look...)        /
 *   ---------------------------------------
 *          \   ^__^
 *           \  (oo)\_______
 *              (__)\       )\/\
 *                  ||----w |
 *                  ||     ||
 *
 */

/** PROIECT
 *
 * stepper.h
 *
 * @author Nitu Ioan Florin Catalin
 * @group 333CC
 * @version 1.0
 * @since Rock 'n' Roll
 *
 * Copyright (c) 2019 PM
 *
 */

#ifndef STEPPER_H_
#define STEPPER_H_

#include <avr/io.h>
#include <util/delay.h>

#define STEPPER_STEPS 512

#define STEPPER_IN1 PD6
#define STEPPER_IN2 PD5
#define STEPPER_IN3 PD4
#define STEPPER_IN4 PB4
#define STEPPER_IN7 PB3

#define STEPPER_DDR_IN123 DDRD
#define STEPPER_PORT_IN123 PORTD
#define STEPPER_PIN_IN123 PIND

#define STEPPER_DDR_IN47 DDRB
#define STEPPER_PORT_IN47 PORTB
#define STEPPER_PIN_IN47 PINB

void STEPPER_init(void);

void STEPPER_set(int in4, int in3, int in2, int in1);

void STEPPER_rotation(int angle);

#endif /* STEPPER_H_ */

